<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: dlib::threaded_object Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacedlib.html">dlib</a></li><li class="navelem"><a class="el" href="classdlib_1_1threaded__object.html">threaded_object</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pri-methods">Private Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="classdlib_1_1threaded__object-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">dlib::threaded_object Class Reference<span class="mlabels"><span class="mlabel">abstract</span></span></div>  </div>
</div><!--header-->
<div class="contents">
<div class="dynheader">
Inheritance diagram for dlib::threaded_object:</div>
<div class="dyncontent">
 <div class="center">
  <img src="classdlib_1_1threaded__object.png" usemap="#dlib::threaded_5Fobject_map" alt=""/>
  <map id="dlib::threaded_5Fobject_map" name="dlib::threaded_5Fobject_map">
<area href="classdlib_1_1gui__core__kernel__2__globals_1_1event__handler__thread.html" alt="dlib::gui_core_kernel_2_globals::event_handler_thread" shape="rect" coords="0,56,478,80"/>
<area href="classdlib_1_1svm__struct__processing__node_1_1node__type.html" alt="dlib::svm_struct_processing_node::node_type&lt; matrix_type, feature_vector_type &gt;" shape="rect" coords="488,56,966,80"/>
<area href="classdlib_1_1thread__function.html" alt="dlib::thread_function" shape="rect" coords="976,56,1454,80"/>
<area href="structdlib_1_1timer__base.html" alt="dlib::timer_base" shape="rect" coords="1464,56,1942,80"/>
<area href="classdlib_1_1timer__global__clock.html" alt="dlib::timer_global_clock" shape="rect" coords="1952,56,2430,80"/>
<area href="classdlib_1_1timer.html" alt="dlib::timer&lt; T &gt;" shape="rect" coords="1952,112,2430,136"/>
<area href="classdlib_1_1timer.html" alt="dlib::timer&lt; color_box &gt;" shape="rect" coords="1952,168,2430,192"/>
<area href="classdlib_1_1timer.html" alt="dlib::timer&lt; dlib::image_display &gt;" shape="rect" coords="1952,224,2430,248"/>
<area href="classdlib_1_1timer.html" alt="dlib::timer&lt; dlib::scroll_bar &gt;" shape="rect" coords="1952,280,2430,304"/>
<area href="classdlib_1_1timer.html" alt="dlib::timer&lt; dlib::text_box &gt;" shape="rect" coords="1952,336,2430,360"/>
<area href="classdlib_1_1timer.html" alt="dlib::timer&lt; dlib::text_field &gt;" shape="rect" coords="1952,392,2430,416"/>
<area href="classdlib_1_1timer.html" alt="dlib::timer&lt; dlib::text_grid &gt;" shape="rect" coords="1952,448,2430,472"/>
<area href="classdlib_1_1timer.html" alt="dlib::timer&lt; dlib::timeout &gt;" shape="rect" coords="1952,504,2430,528"/>
<area href="classdlib_1_1timer.html" alt="dlib::timer&lt; dlib::tooltip &gt;" shape="rect" coords="1952,560,2430,584"/>
  </map>
</div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:adf50fff115d12c008884f58baac4e5ca"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1threaded__object.html#adf50fff115d12c008884f58baac4e5ca">threaded_object</a> ()</td></tr>
<tr class="separator:adf50fff115d12c008884f58baac4e5ca"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab80a178cdc8f8fc51e8583c26f5d0714"><td class="memItemLeft" align="right" valign="top"><a id="ab80a178cdc8f8fc51e8583c26f5d0714"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>is_running</b> () const</td></tr>
<tr class="separator:ab80a178cdc8f8fc51e8583c26f5d0714"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abb6e0d0cfebb8a73d2dda75d7c0c2a16"><td class="memItemLeft" align="right" valign="top"><a id="abb6e0d0cfebb8a73d2dda75d7c0c2a16"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>is_alive</b> () const</td></tr>
<tr class="separator:abb6e0d0cfebb8a73d2dda75d7c0c2a16"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abc1dfba4cec8c05f5cc068cfc0ff073b"><td class="memItemLeft" align="right" valign="top"><a id="abc1dfba4cec8c05f5cc068cfc0ff073b"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>wait</b> () const</td></tr>
<tr class="separator:abc1dfba4cec8c05f5cc068cfc0ff073b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a055c8a1d8daf7876a91e890e3f2fc03d"><td class="memItemLeft" align="right" valign="top"><a id="a055c8a1d8daf7876a91e890e3f2fc03d"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>start</b> ()</td></tr>
<tr class="separator:a055c8a1d8daf7876a91e890e3f2fc03d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3ab7c9f3bba2fd9c91a069a127e3c02d"><td class="memItemLeft" align="right" valign="top"><a id="a3ab7c9f3bba2fd9c91a069a127e3c02d"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>restart</b> ()</td></tr>
<tr class="separator:a3ab7c9f3bba2fd9c91a069a127e3c02d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a504466de60a611ab0c4f15525e6b2872"><td class="memItemLeft" align="right" valign="top"><a id="a504466de60a611ab0c4f15525e6b2872"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>set_respawn</b> ()</td></tr>
<tr class="separator:a504466de60a611ab0c4f15525e6b2872"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a423f38bc010e36b0f8a8220172166947"><td class="memItemLeft" align="right" valign="top"><a id="a423f38bc010e36b0f8a8220172166947"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>should_respawn</b> () const</td></tr>
<tr class="separator:a423f38bc010e36b0f8a8220172166947"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a100d7aff9093b5ca3ad2847340fbc74c"><td class="memItemLeft" align="right" valign="top"><a id="a100d7aff9093b5ca3ad2847340fbc74c"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>pause</b> ()</td></tr>
<tr class="separator:a100d7aff9093b5ca3ad2847340fbc74c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a769510e346ee93e5d3337c4591cd358d"><td class="memItemLeft" align="right" valign="top"><a id="a769510e346ee93e5d3337c4591cd358d"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>stop</b> ()</td></tr>
<tr class="separator:a769510e346ee93e5d3337c4591cd358d"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr class="memitem:a8c965067e39218bd9fcea5c699150e68"><td class="memItemLeft" align="right" valign="top"><a id="a8c965067e39218bd9fcea5c699150e68"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>should_stop</b> () const</td></tr>
<tr class="separator:a8c965067e39218bd9fcea5c699150e68"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-methods"></a>
Private Member Functions</h2></td></tr>
<tr class="memitem:add38891f6697edf4ab300489693e8f72"><td class="memItemLeft" align="right" valign="top"><a id="add38891f6697edf4ab300489693e8f72"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>thread_helper</b> ()</td></tr>
<tr class="separator:add38891f6697edf4ab300489693e8f72"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab739ecde260df66acebf9bd81705132d"><td class="memItemLeft" align="right" valign="top"><a id="ab739ecde260df66acebf9bd81705132d"></a>
virtual void&#160;</td><td class="memItemRight" valign="bottom"><b>thread</b> ()=0</td></tr>
<tr class="separator:ab739ecde260df66acebf9bd81705132d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a813ec1d79422306a910eba3dfe9008af"><td class="memItemLeft" align="right" valign="top"><a id="a813ec1d79422306a910eba3dfe9008af"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>threaded_object</b> (<a class="el" href="classdlib_1_1threaded__object.html">threaded_object</a> &amp;)</td></tr>
<tr class="separator:a813ec1d79422306a910eba3dfe9008af"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a16f898c202bca94d76dd9893f6e4d584"><td class="memItemLeft" align="right" valign="top"><a id="a16f898c202bca94d76dd9893f6e4d584"></a>
<a class="el" href="classdlib_1_1threaded__object.html">threaded_object</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator=</b> (<a class="el" href="classdlib_1_1threaded__object.html">threaded_object</a> &amp;)</td></tr>
<tr class="separator:a16f898c202bca94d76dd9893f6e4d584"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:a640bf06caa0d8acf71a52d6c3933360d"><td class="memItemLeft" align="right" valign="top"><a id="a640bf06caa0d8acf71a52d6c3933360d"></a>
<a class="el" href="classdlib_1_1mutex.html">mutex</a>&#160;</td><td class="memItemRight" valign="bottom"><b>m_</b></td></tr>
<tr class="separator:a640bf06caa0d8acf71a52d6c3933360d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9d1fec4b9537800a17f8ca36e0a031ac"><td class="memItemLeft" align="right" valign="top"><a id="a9d1fec4b9537800a17f8ca36e0a031ac"></a>
<a class="el" href="classdlib_1_1signaler.html">signaler</a>&#160;</td><td class="memItemRight" valign="bottom"><b>s</b></td></tr>
<tr class="separator:a9d1fec4b9537800a17f8ca36e0a031ac"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6fadb27901ee75554e7e76d383466aa4"><td class="memItemLeft" align="right" valign="top"><a id="a6fadb27901ee75554e7e76d383466aa4"></a>
thread_id_type&#160;</td><td class="memItemRight" valign="bottom"><b>id1</b></td></tr>
<tr class="separator:a6fadb27901ee75554e7e76d383466aa4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1db41116f5b38c63d22fbdc4a4092aa2"><td class="memItemLeft" align="right" valign="top"><a id="a1db41116f5b38c63d22fbdc4a4092aa2"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>is_running_</b></td></tr>
<tr class="separator:a1db41116f5b38c63d22fbdc4a4092aa2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6c9e2532b86c5bab15f75856b92c263f"><td class="memItemLeft" align="right" valign="top"><a id="a6c9e2532b86c5bab15f75856b92c263f"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>is_alive_</b></td></tr>
<tr class="separator:a6c9e2532b86c5bab15f75856b92c263f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab4982ce666287a566b458092f50e01ad"><td class="memItemLeft" align="right" valign="top"><a id="ab4982ce666287a566b458092f50e01ad"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>should_stop_</b></td></tr>
<tr class="separator:ab4982ce666287a566b458092f50e01ad"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a78a914d0e3cb9a6320a34e4f35c098fb"><td class="memItemLeft" align="right" valign="top"><a id="a78a914d0e3cb9a6320a34e4f35c098fb"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>should_respawn_</b></td></tr>
<tr class="separator:a78a914d0e3cb9a6320a34e4f35c098fb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a71fa3af06e79f0bb474e2cc416069e9b"><td class="memItemLeft" align="right" valign="top"><a id="a71fa3af06e79f0bb474e2cc416069e9b"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>id_valid</b></td></tr>
<tr class="separator:a71fa3af06e79f0bb474e2cc416069e9b"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="adf50fff115d12c008884f58baac4e5ca"></a>
<h2 class="memtitle"><span class="permalink"><a href="#adf50fff115d12c008884f58baac4e5ca">&#9670;&nbsp;</a></span>threaded_object()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">dlib::threaded_object::threaded_object </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">        INITIAL VALUE
            - is_running_ == false
            - is_alive_ == false 
            - should_stop_ == false
            - should_respawn_ == false
</pre><p>#ifdef ENABLE_ASSERTS</p><ul>
<li>id_valid == false</li>
<li>id1 == get_main_thread_id() #endif <pre class="fragment">        CONVENTION
            - is_running() == is_running_
            - is_alive() == is_alive_
            - should_stop() == should_stop_
            - should_respawn() == should_respawn_
</pre></li>
</ul>
<p>#ifdef ENABLE_ASSERTS</p><ul>
<li>if (when thread() is executing) then<ul>
<li>id1 == the id of the running thread</li>
<li>id_valid == true</li>
</ul>
</li>
<li>else<ul>
<li>id1 == an undefined value</li>
<li>id_valid == false #endif <pre class="fragment">            - m_ == the mutex used to protect all our variables
            - s == the signaler for m_
    !
</pre> </li>
</ul>
</li>
</ul>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="threaded__object__extension_8h_source.html">threaded_object_extension.h</a></li>
<li>threaded_object_extension.cpp</li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
